//
//  GetTelephoneListRestClient.m
//  Downloader
//
//  Created by Martin Dvoracek on 4/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "GetTelephoneListRestClient.h"
#import "TelephoneItem.h"



@implementation GetTelephoneListRestClient
@synthesize results;
@synthesize controller;
-(id)init {
	self = [super init];
	results = [[NSMutableArray alloc]init];
	return self;
}

-(void)getTelephoneList:(id)controll {
	self.controller = controll;
	NSString *urlString =  @"https://findatab.fincentrum.com/AndroidWCF/Service1.svc/rest/TestMethod";
	NSURL *url = [NSURL URLWithString:urlString];
	[UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
	NSURLRequest *req = [NSURLRequest requestWithURL:url cachePolicy:NSURLRequestReloadIgnoringCacheData timeoutInterval:30.0];
	[NSURLConnection connectionWithRequest:req delegate:self];
	return;
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	if ([response isKindOfClass:[NSHTTPURLResponse class]]) {
		NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *) response;
		int status = [httpResponse statusCode];
		
		if (!((status >= 200) && (status < 300))) {
			[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
		} else {
			// make the working space for the REST data buffer.  This could also be a file if you want to reduce the RAM footprint
			[wipData release];
			wipData = [[NSMutableData alloc] initWithCapacity:1024];
		}
	}
	
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[wipData appendData:data];
}
	 
	 
- (void)connectionDidFinishLoading:(NSURLConnection *)conn {
		 // do a little debug dump
		 NSString *xml = [[NSString alloc] initWithData:wipData encoding:NSUTF8StringEncoding];
		 [xml release];
		 
		 [self parseDocument:wipData];
		 
		 // after parsing, call the controller to report that the tranfer is done
		 if ([controller respondsToSelector:@selector(updateTable:)]) {
			 [controller performSelector:@selector(updateTable:) withObject:results];
		 }
		 // turn off the network indicator
		 [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
		 
	 }
	 //
	 // Something bad happened before the response started
	 //
	 - (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
		 NSLog(@"Connection failed");
		 
		 [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
	 }
	 //
	 // called when a new element is encountered in the XML stream
	 //
	 - (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict
	{
		[self clearContentsOfElement];
		
		if ([elementName isEqualToString:@"Device"]) {
			wipTelephone = [[TelephoneItem alloc] init];
		}
	}
	 //
	 // Called at the end of an element
	 //
	 - (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName 
	{     
		if ([elementName isEqualToString:@"Device"]) {
			// save the work in progress user to the results, which increments the retain count
			[results addObject:wipTelephone];
			[wipTelephone release];
			wipTelephone = nil;
			
		} else if ([elementName isEqualToString:@"NotificationID"]) {
			[wipTelephone setNotificationID:[NSNumber numberWithInt:[_contentsOfElement intValue]]];
			
		} else if ([elementName isEqualToString:@"CellPhone"]) {
			[wipTelephone setCellPhone: _contentsOfElement];
		} 
		else if ([elementName isEqualToString:@"Message"]) {
			[wipTelephone setMessage:_contentsOfElement];
		}
		else if([elementName isEqualToString:@"StatusCode"]) {
			[wipTelephone setStatusCode:_contentsOfElement];
		}

		[self clearContentsOfElement];
	}
	 
	 - (void) dealloc {
		 [wipTelephone release];
		 [wipData release];
		 [results release];
		 [controller release];
		 
		 [super dealloc];
	 }


@end
