

#import "TelephoneItemTableViewControler.h"
#import "GetTelephoneListRestClient.h"
#import "TelephoneItem.h"


@implementation TelephoneItemTableViewControler
@synthesize cellPhoneID;
@synthesize telephoneItem;

#pragma mark -
#pragma mark Initialization



#pragma mark -
#pragma mark View lifecycle


#pragma mark -
#pragma mark Table view data source


-(id)initWithStyle:(UITableViewStyle)style {
	self = [initWithStyle: style];
	return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
	
	GetTelephoneListRestClient *phone = [[GetTelephoneListRestClient alloc] init];
	self.telephoneItem = [phone getTelephoneList:self.cellPhoneID];
	[client release];
	
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
	if (telephoneItem != null) {
		return 3;
	}
	else {
		return 0;
	}
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
	
	// Set up the cell...
	if (indexPath.row == 0) {
		
		cell.textLabel.text = @"Id";
		cell.detailTextLabel.text = [NSString stringWithFormat:@"%@", [telephoneItem NotificationID]];
	} else if (indexPath.row == 1) {
		cell.textLabel.text = @"CellPhone";
		cell.detailTextLabel.text = [telephoneItem CellPhone];
	} else if (indexPath.row == 2) {
		
		cell.textLabel.text = @"Message";
		cell.detailTextLabel.text = [telephoneItem Message];
	}
	
	
    
    return cell;
}





#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
	[telephoneItem release];
	[CellPhoneID release]
    [super dealloc];
}


@end

