

#import "soapClass.h"


@implementation soapClass
@synthesize soapTextView;

-(IBAction)downloadSoap {
	
	NSString *soapMessage = [NSString stringWithFormat:						
							 @"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
							 "<SOAP-ENV:Envelope\n" 
							 "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
							 "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
							 "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
							 "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
							 "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
							 "<SOAP-ENV:Body>\n"
							 "<TestMethod xmlns=\"http://tempuri.org/\">\n"							 
							 ];
	
	NSString *pripona = [NSString stringWithFormat:
						 @"</TestMethod>\n"
						 "</SOAP-ENV:Body>\n"
						 "</SOAP-ENV:Envelope>\n"];			
							 
	soapMessage = [soapMessage stringByAppendingString:pripona];
	
	NSURL *url = [NSURL URLWithString:@"https://findatab.fincentrum.com/AndroidWCF/Service1.svc/soap"];
	
	
	NSMutableURLRequest *theRequest = [NSMutableURLRequest requestWithURL:url];
	NSString *msgLength = [NSString stringWithFormat:@"%d", [soapMessage length]];
	
	[theRequest addValue: @"text/xml; charset=utf-8" forHTTPHeaderField:@"Content-Type"];
	[theRequest addValue: @"http://tempuri.org/IService1/TestMethod" forHTTPHeaderField:@"SOAPAction"];
	[theRequest addValue: msgLength forHTTPHeaderField:@"Content-Length"];
	[theRequest setHTTPMethod:@"POST"];
	[theRequest setHTTPBody: [soapMessage dataUsingEncoding:NSUTF8StringEncoding]];
	
	NSURLConnection *theConnection = [[NSURLConnection alloc] initWithRequest:theRequest delegate:self];
	if( theConnection )
	{
		webData = [[NSMutableData data] retain];
	}
	else
	{
		NSLog(@"theConnection is NULL");
	} 	
}

-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
	[webData setLength: 0];
}
-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
	[webData appendData:data];
}
-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
	NSLog(@"ERROR with theConenction");
	[connection release];
	[webData release];
}

-(void)connectionDidFinishLoading:(NSURLConnection *)connection
{
	NSString *xmlResponse; 
	NSLog(@"DONE. Received Bytes: %d", [webData length]);
	NSString *theXML = [[NSString alloc] initWithBytes: [webData mutableBytes] length:[webData length] encoding:NSUTF8StringEncoding];
	
	NSString *existingString = @"<a:CellPhone>";
	NSString *existingStringStop = @"</a:CellPhone>";
	
	NSString *messageTagStart = @"<a:Message>";
	NSString *messageTagStop = @"</a:Message>";
	
	NSString *notificationTagStart = @"<a:NotificationID>";
	NSString *notificationTagStop = @"</a:NotificationID>";
	
	NSString *statusTagStart = @"<a:StatusCode>";
	NSString *statusTagStop = @"</a:StatusCode>";
	
	NSRange existRangeIDStart = [theXML rangeOfString:existingString];
	NSRange existRangeIDStop = [theXML rangeOfString:existingStringStop];
	
	NSRange messageRangeStart = [theXML rangeOfString:messageTagStart];
	NSRange messageRangeStop = [theXML rangeOfString:messageTagStop];
	
	NSRange notificationRangeStart = [theXML rangeOfString:notificationTagStart];
	NSRange notificationRangeStop = [theXML rangeOfString:notificationTagStop];
	
	NSRange statusRangeStart = [theXML rangeOfString:statusTagStart];
	NSRange statusRangeStop = [theXML rangeOfString:statusTagStop];	
	
	if(existRangeIDStart.length > 0) {
		int poziceDatStringStart = existRangeIDStart.location + existRangeIDStart.length;
		int poziceDatStringStop = existRangeIDStop.location;
		
		int positionMessageStart = messageRangeStart.location + messageRangeStart.length;
		int positionMessageStop = messageRangeStop.location;
		
		int positionNotificationStart = notificationRangeStart.location + notificationRangeStart.length;
		int positionNotificationStop = notificationRangeStop.location;	
		
		int positionStatusStart = statusRangeStart.location + statusRangeStart.length;
		int positionStatusStop = statusRangeStop.location;			
		
		NSString *cellPhone = [theXML substringToIndex:poziceDatStringStop];
		cellPhone = [cellPhone substringFromIndex:poziceDatStringStart];
		
		NSString *message = [theXML substringToIndex:positionMessageStop];
		message = [message substringFromIndex:positionMessageStart];
		
		NSString *notification = [theXML substringToIndex:positionNotificationStop];
		notification = [notification substringFromIndex:positionNotificationStart];	
		
		NSString *status = [theXML substringToIndex:positionStatusStop];
		status = [status substringFromIndex:positionStatusStart];			
		
		 xmlResponse = [[NSString alloc]initWithFormat:@"ID: %@ \nPhone No.: %@ \nMessage: %@ \nStatus code: %@",notification,cellPhone,message,status];
	}
	
	soapTextView.text = xmlResponse;
		[theXML release];
	[connection release];
	[webData release];	
}



- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
