

#import "synchronousRestClass.h"


@implementation synchronousRestClass
@synthesize restTextView;


-(IBAction)restDownload {
	NSURL *url = [NSURL URLWithString:@"https://findatab.fincentrum.com/AndroidWCF/Service1.svc/rest/GetXml/new.xml"]; 
	NSURLRequest *request = [NSURLRequest requestWithURL:url];
	NSURLResponse *response;
	NSString *xmlResponse;
	NSError *error;
	NSData *plistData;
	plistData = [NSURLConnection sendSynchronousRequest:request
									  returningResponse:&response error:&error];
	
	// parse the HTTP response into a plist
	NSPropertyListFormat format;
	id theXML;
	NSString *errorStr;
	theXML = [NSPropertyListSerialization propertyListFromData:plistData
											 mutabilityOption:NSPropertyListImmutable
													   format:&format
											 errorDescription:&errorStr];
	if(!theXML) {
		restTextView.text = errorStr;
	} else {
		//soapTextView.text = theXML;
		NSString *existingString = @"<Name>";
		NSString *existingStringStop = @"</Name>";
		
		NSString *messageTagStart = @"<Description>";
		NSString *messageTagStop = @"</Description>";
		
		NSString *notificationTagStart = @"<Platform>";
		NSString *notificationTagStop = @"</Platform>";
		
		//NSString *statusTagStart = @"<a:StatusCode>";
		//NSString *statusTagStop = @"</a:StatusCode>";
		
		NSRange existRangeIDStart = [theXML rangeOfString:existingString];
		NSRange existRangeIDStop = [theXML rangeOfString:existingStringStop];
		
		NSRange messageRangeStart = [theXML rangeOfString:messageTagStart];
		NSRange messageRangeStop = [theXML rangeOfString:messageTagStop];
		
		NSRange notificationRangeStart = [theXML rangeOfString:notificationTagStart];
		NSRange notificationRangeStop = [theXML rangeOfString:notificationTagStop];
		
		//NSRange statusRangeStart = [theXML rangeOfString:statusTagStart];
		//NSRange statusRangeStop = [theXML rangeOfString:statusTagStop];	
		
		if(existRangeIDStart.length > 0) {
			int poziceDatStringStart = existRangeIDStart.location + existRangeIDStart.length;
			int poziceDatStringStop = existRangeIDStop.location;
			
			int positionMessageStart = messageRangeStart.location + messageRangeStart.length;
			int positionMessageStop = messageRangeStop.location;
			
			int positionNotificationStart = notificationRangeStart.location + notificationRangeStart.length;
			int positionNotificationStop = notificationRangeStop.location;	
			
			//int positionStatusStart = statusRangeStart.location + statusRangeStart.length;
			//int positionStatusStop = statusRangeStop.location;			
			
			NSString *cellPhone = [theXML substringToIndex:poziceDatStringStop];
			cellPhone = [cellPhone substringFromIndex:poziceDatStringStart];
			
			NSString *message = [theXML substringToIndex:positionMessageStop];
			message = [message substringFromIndex:positionMessageStart];
			
			NSString *notification = [theXML substringToIndex:positionNotificationStop];
			notification = [notification substringFromIndex:positionNotificationStart];	
			
			//NSString *status = [theXML substringToIndex:positionStatusStop];
			//status = [status substringFromIndex:positionStatusStart];			
			
			xmlResponse = [[NSString alloc]initWithFormat:@"Name: %@ \nDescription No.: %@ \nPlatform: %@",notification,cellPhone,message];		
		
		restTextView.text = xmlResponse;
		}
	}
	
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[restTextView release];
    [super dealloc];
}


@end
