package cz.utb.downloader;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.ArrayList;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import android.util.Xml;

public class DevicesParser {
	private ArrayList<XmlStructure> devices;
	
	public ArrayList<XmlStructure> getDevices() {
		return devices;
	}

	public void parseDevices(String xmlList) {
		// TODO Auto-generated method stub
		try {
			//XmlPullParserFactory factory = XmlPullParserFactory.newInstance();
			XmlPullParser parser = Xml.newPullParser();// .newPullParser();
			parser.setInput(new ByteArrayInputStream(xmlList.getBytes()), "UTF-8");			
			int eventType = parser.getEventType();
			XmlStructure currentStructure = null;
			ArrayList<MyAttribute> attributes = null;
			MyAttribute attribute = null;
			boolean done = false;
			while (eventType != org.xmlpull.v1.XmlPullParser.END_DOCUMENT && !done) {
				String name = null;
				switch (eventType) {
				case org.xmlpull.v1.XmlPullParser.START_DOCUMENT:
						devices = new ArrayList<XmlStructure>();
					break;
				case org.xmlpull.v1.XmlPullParser.START_TAG:
					name = parser.getName();
					 if (name.equalsIgnoreCase(Constants.DEVICE)){
                         currentStructure = new XmlStructure();
                     } else if (currentStructure != null){
                         if (name.equalsIgnoreCase(Constants.PLATFORM)){
                        	 currentStructure.setPlatform(parser.nextText());
                         } else if (name.equalsIgnoreCase(Constants.DESCRIPTION)){
                        	 currentStructure.setDescription(parser.nextText());
                         } else if (name.equalsIgnoreCase(Constants.NAME)){
                        	 currentStructure.setDeviceName(parser.nextText());
                         }   
                         else if(name.equalsIgnoreCase(Constants.ATTRIBUTES)) {
                        	 attributes = new ArrayList<MyAttribute>();
                         }
                         else if(name.equalsIgnoreCase(Constants.ATTRIBUTE)) {
                        	 attribute = new MyAttribute();
                         }
                         else if(name.equalsIgnoreCase(Constants.ATTRIBUTE_NAME)) {
                        	 attribute.setName(parser.nextText());
                         }
                         else if(name.equalsIgnoreCase(Constants.ATTRIBUTE_VALUE)) {
                        	 attribute.setValue(parser.nextText());
                         }
                         else if(name.equalsIgnoreCase(Constants.ATTRIBUTE_DESCRIPTION)) {
                        	 attribute.setDescription(parser.nextText());
                         }
                     }
					break;
				case org.xmlpull.v1.XmlPullParser.END_TAG:
					name = parser.getName();
                    if (name.equalsIgnoreCase(Constants.DEVICE) && currentStructure != null){
                        devices.add(currentStructure);
                    } else if (name.equalsIgnoreCase(Constants.DEVICESLIST)){
                        done = true;
                    }
                    else if(name.equalsIgnoreCase(Constants.ATTRIBUTES)) {
                    	currentStructure.setAttributes(attributes);
                    }
                    else if(name.equalsIgnoreCase(Constants.ATTRIBUTE)) {
                    	attributes.add(attribute);
                    }
					break;
				}
				eventType = parser.next();
			}
		} catch (XmlPullParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
