package cz.utb.downloader;


import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class DownloaderActivity extends Activity {
	
	SharedPreferences sharedPreferences;
	Button btnSoap;
	Button btnRest;
	MyApp app;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        app = ((MyApp)getApplicationContext());
        //CheckPreferences();
        
        btnSoap = (Button)findViewById(R.id.button1);
        btnRest = (Button)findViewById(R.id.button2);
        
        btnSoap.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Intent i = new Intent(getApplicationContext(), SoapActivity.class);
				startActivity(i);
			}
		});
        
        
        btnRest.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(getApplicationContext(), RestActivity.class);
				startActivity(intent);
			}
		});
    }
	private void CheckPreferences() {
		// TODO Auto-generated method stub
		sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
        app.setIP_SOAP(sharedPreferences.getString("ip_option_soap", ""));
        app.setSCHEMA_SOAP(sharedPreferences.getString("schema_option_soap", "http://"));
        app.setIP_REST(sharedPreferences.getString("ip_option_rest",""));
        app.setSCHEMA_REST(sharedPreferences.getString("schema_option_rest", "http://"));
        app.setFUNCTION_PATH_REST(sharedPreferences.getString("path_option_rest", ""));
        app.setSELFSIGNED(sharedPreferences.getBoolean("selfSigned_option_soap", false));
        app.setFILENAME_SOAP(sharedPreferences.getString("fileName_option_rest", ""));
        
        if(app.getIP_SOAP().length()<1 && (app.getIP_REST().length() <1 && app.getFUNCTION_PATH_REST().length() < 1)) {
        	Toast.makeText(this, "Must set connection options.", Toast.LENGTH_LONG).show();
        	Intent intent = new Intent(this, Options.class);
        	startActivity(intent);
        	return;
        	}
        if(app.getFILENAME_SOAP().length() < 1 || app.getFILENAME_SOAP().equals("")) {
        	Toast.makeText(this, "Must set th name of the file.", Toast.LENGTH_LONG).show();
        	Intent intent = new Intent(this, Options.class);
        	startActivity(intent);
        	return;
        }
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// TODO Auto-generated method stub
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.options_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// TODO Auto-generated method stub
		switch(item.getItemId()) {
		case R.id.option_menu:
			Intent i = new Intent(this, Options.class);
			startActivity(i);
		break;
		}
		return super.onOptionsItemSelected(item);
	}
	
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		CheckPreferences();
	}
}