package cz.utb.downloader;

import java.io.IOException;
import java.util.ArrayList;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class RestActivity extends ListActivity {
	MyApp app;
	ListView lvDevices;
	ArrayList<XmlStructure> devices;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.devices_list);
		setTitle("REST channel");
		app = ((MyApp)getApplicationContext());
		
		lvDevices = getListView();
		RestDownloadManager manager = new RestDownloadManager(app.getIP_REST(), app.getSCHEMA_REST(), app.getFUNCTION_PATH_REST());
		String file = app.getFILENAME_SOAP().endsWith(".xml") ? app.getFILENAME_SOAP() : app.getFILENAME_SOAP()+".xml";
		manager.AddParameters(file);
		String response = null;
		String xmlList = null;
		devices = new ArrayList<XmlStructure>();
		try {
			if(app.getSCHEMA_REST().equals("http://")) {
				response = manager.HttpConnect();
			}
			else {
				response = manager.HttpsConnect();
			}
			Toast.makeText(this, "Time: " + (double)(RestDownloadManager.DownloadTime)/1000 + " s", Toast.LENGTH_LONG).show();
			xmlList = response.substring(1,response.length()-1);
			DevicesParser parser = new DevicesParser();
			parser.parseDevices(xmlList);
			devices = parser.getDevices();
			app.setDevices(devices);			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ArrayList<String> devicesNames = new ArrayList<String>();
		for (XmlStructure device : devices) {
			devicesNames.add(device.getDeviceName());				
		}
		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, devicesNames));
		lvDevices.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position,
					long id) {
				// TODO Auto-generated method stub
				Intent i = new Intent(getApplicationContext(),DeviceDetail.class);
				i.putExtra("devicePosition", position);
				startActivity(i);
			}
		});
	}

}
