package cz.utb.downloader;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringWriter;
import java.io.Writer;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;

import javax.net.ssl.HttpsURLConnection;

import org.apache.http.conn.ssl.AllowAllHostnameVerifier;


public class RestDownloadManager {
	private String IP;
	private String SCHEMA;
	private String PATH;
	private ArrayList<String> values;
	public static long DownloadTime;
	
	public RestDownloadManager(String IP,String Schema,String Path) {
		// TODO Auto-generated constructor stub
		this.IP = IP;
		this.SCHEMA = Schema;
		this.PATH = Path;
		values = new ArrayList<String>();
	}
	
	public void AddParameters(String value) {
		values.add(value);
	}
	
	public String HttpConnect() throws IOException {
		String parameters = new String();
		for (String parameter : values) {
			parameters += "/"+URLEncoder.encode(parameter,"UTF-8");
		}
		 String target = ((SCHEMA.endsWith("/") || IP.startsWith("/"))  ? SCHEMA : SCHEMA+"/")+ ((IP.endsWith("/") || PATH.startsWith("/")) ? IP : IP + "/") + (PATH.endsWith("/") ? PATH.substring(0, PATH.length()-1) : PATH)+parameters;
	        //String NETTarget = NET_SERVER_URL + NET_SERVICE_PATH;
	        URL url = new URL(target);

	        HttpURLConnection httpConnection = (HttpURLConnection) url.openConnection();
	       // httpConnection.setHostnameVerifier(new AllowAllHostnameVerifier());
	       // httpConnection.setRequestProperty("Host", "findatab.fincentrum.com");// addRequestProperty("Host", "172.16.1.103");
	        httpConnection.setConnectTimeout(5000);
	        httpConnection.setRequestMethod("GET");
	        httpConnection.setInstanceFollowRedirects(false);
	        httpConnection.setUseCaches(false);
	        httpConnection.setDoOutput(true);
	        httpConnection.setDoInput(true);
	        long startTime = System.currentTimeMillis();
	        httpConnection.connect();
	        long endTime = System.currentTimeMillis();
	        DownloadTime = (endTime-startTime);
	        int responseCode = httpConnection.getResponseCode();
	        InputStream inputStream;
	        if (responseCode == 200) {
	            inputStream = httpConnection.getInputStream();
	        } else {
	            inputStream = httpConnection.getErrorStream();
	            if (inputStream == null) {
	                //System.out.println("Nastala chyba: " + httpConnection.getResponseMessage());
	            	//Log.i("Connection problem: ", httpConnection.getResponseMessage());
	            return(null);
	            }
	        }
	        //return inputStream;
	         /*s webservicama zasadne v UTF-8 */
	        InputStreamReader reader = new InputStreamReader(inputStream, "UTF-8");
	        StringWriter wr = new StringWriter();
	        copyReaderToWriter(reader, wr);
	        String xmlFile = wr.getBuffer().toString();
	        xmlFile = xmlFile.replace("\\", "");
	        //System.out.println("Ziskane XML:\n" + wr.getBuffer().toString());
	        return xmlFile;//wr.getBuffer().toString();	
		
	}
	
	public String HttpsConnect() throws IOException {
		String parameters = new String();
		for (String parameter : values) {
			parameters += "/"+URLEncoder.encode(parameter,"UTF-8");
		}
		 String target = ((SCHEMA.endsWith("/") || IP.startsWith("/"))  ? SCHEMA : SCHEMA+"/")+ ((IP.endsWith("/") || PATH.startsWith("/")) ? IP : IP + "/") + (PATH.endsWith("/") ? PATH.substring(0, PATH.length()-1) : PATH)+parameters;
	        //String NETTarget = NET_SERVER_URL + NET_SERVICE_PATH;
	        URL url = new URL(target);

	        HttpsURLConnection httpsConnection = (HttpsURLConnection) url.openConnection();
	        httpsConnection.setHostnameVerifier(new AllowAllHostnameVerifier());
	       // httpConnection.setRequestProperty("Host", "findatab.fincentrum.com");// addRequestProperty("Host", "172.16.1.103");
	        httpsConnection.setConnectTimeout(5000);
	        httpsConnection.setRequestMethod("GET");
	        httpsConnection.setInstanceFollowRedirects(false);
	        httpsConnection.setUseCaches(false);
	        httpsConnection.setDoOutput(true);
	        httpsConnection.setDoInput(true);
	        long startTime = System.currentTimeMillis();
	        httpsConnection.connect();
	        long endTime = System.currentTimeMillis();
	        DownloadTime = (endTime-startTime);
	        int responseCode = httpsConnection.getResponseCode();
	        InputStream inputStream;
	        if (responseCode == 200) {
	            inputStream = httpsConnection.getInputStream();
	        } else {
	            inputStream = httpsConnection.getErrorStream();
	            if (inputStream == null) {
	                //System.out.println("Nastala chyba: " + httpConnection.getResponseMessage());
	            	//Log.i("Connection problem: ", httpConnection.getResponseMessage());
	            return(null);
	            }
	        }
	        //return inputStream;
	         /*s webservicama zasadne v UTF-8 */
	        InputStreamReader reader = new InputStreamReader(inputStream, "UTF-8");
	        StringWriter wr = new StringWriter();
	        copyReaderToWriter(reader, wr);
	        String xmlFile = wr.getBuffer().toString();
	        xmlFile = xmlFile.replace("\\", "");
	        //System.out.println("Ziskane XML:\n" + wr.getBuffer().toString());
	        return xmlFile;//wr.getBuffer().toString();	
		
	}
	
	 public static long copyReaderToWriter(Reader reader, Writer writer) throws IOException {

	        long pocet = 0;
	        int count;
	        char[] buffer = new char[8192];
	        while ((count = reader.read(buffer, 0, 8192)) != -1) {
	            writer.write(buffer, 0, count);
	            pocet += count;
	        }
	        return pocet;

	    }


}
