package cz.utb.downloader;

import java.util.ArrayList;

import org.ksoap2.SoapEnvelope;
import org.ksoap2.serialization.SoapPrimitive;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

public class SoapActivity extends ListActivity {
	private String xmlList;
	private ArrayList<XmlStructure> devices;
	private ArrayList<String> devicesNames;
	ListView lvDevices;
	MyApp app;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.devices_list);
		setTitle("SOAP channel");
		app = ((MyApp)getApplicationContext());
		lvDevices = getListView();
		SoapDownloadManager soapDownloader = new SoapDownloadManager(app.getIP_SOAP(), "http://tempuri.org/IService1/GetXml", "GetXml", app.getSCHEMA_SOAP(), SoapEnvelope.VER11,app.getSELFSIGNED());
		soapDownloader.AddProperties("xmlFileName", "new.xml");
		soapDownloader.CreateRequest();
		SoapPrimitive responseObject;
		//if(app.getSCHEMA_SOAP().equals("http://"))
			responseObject = (SoapPrimitive)soapDownloader.HttpCall();
			Toast.makeText(this,"Time: " + (double)(SoapDownloadManager.DownloadTime)/1000 + " s", Toast.LENGTH_LONG).show();
		//else 
			//responseObject = (SoapPrimitive)soapDownloader.HttpsCall();
		if(responseObject == null) {
			Toast.makeText(this, "No data downloaded.", Toast.LENGTH_LONG).show();
			finish();
			return;
		}
		xmlList = responseObject.toString();
		
		DevicesParser parser = new DevicesParser();
		parser.parseDevices(xmlList);
		devices = parser.getDevices();
		
		((MyApp)getApplicationContext()).setDevices(devices);
		devicesNames = new ArrayList<String>();
		for (XmlStructure device : devices) {
			devicesNames.add(device.getDeviceName());
		}
		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1,devicesNames));
		lvDevices.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position,
					long id) {
				Intent i = new Intent(getApplicationContext(),DeviceDetail.class);
				i.putExtra("devicePosition", position);
				startActivity(i);
			}
		});
	}
	
	

}
