package cz.utb.downloader;

import java.io.IOException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import org.apache.http.conn.ssl.AllowAllHostnameVerifier;
import org.ksoap2.serialization.PropertyInfo;
import org.ksoap2.serialization.SoapObject;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.ksoap2.transport.HttpTransportSE;
import org.xmlpull.v1.XmlPullParserException;

public class SoapDownloadManager {
	
	private String URL;
	private String SCHEMA;
	private String NAMESPACE = "http://tempuri.org/";
	private String METHOD;
	private String ACTION;
	private int soapVersion;
	private SoapObject Request;
	private SoapSerializationEnvelope soapEnvelope;
	private ArrayList<PropertyInfo> properties;
	public static long DownloadTime;
	private boolean selfSigned;

	public SoapDownloadManager(String URL,String Action,String Method,String Schema,int soapVersion,boolean selfSignedCertificate) {
		this.URL = URL;
		this.SCHEMA = Schema;
		this.METHOD = Method;
		this.ACTION = Action;
		this.soapVersion = soapVersion;
		this.selfSigned = selfSignedCertificate;
		properties = new ArrayList<PropertyInfo>();

	}
	
	public void AddProperties(String name,Object value) {
		PropertyInfo property = new PropertyInfo();
		property.setName(name);
		property.setValue(value);
		properties.add(property);
		
	}
	public void CreateRequest() {
		Request = new SoapObject(NAMESPACE, METHOD);
		if(properties.size() != 0) {
			for (PropertyInfo info : properties) {
				Request.addProperty(info);
			}
		}
		soapEnvelope = new SoapSerializationEnvelope(soapVersion);
		soapEnvelope.dotNet = true;
		soapEnvelope.setOutputSoapObject(Request);
	}
	
	public Object HttpCall() {
		
		String url = this.SCHEMA+this.URL;
		HttpTransportSE transport = new HttpTransportSE(url);
		Object response = null;
		try {
			if(this.selfSigned) {
				try {
					trustCallback();
				} catch (KeyManagementException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchAlgorithmException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			long startTime = System.currentTimeMillis();
			transport.call(this.ACTION, soapEnvelope);
			response = soapEnvelope.getResponse();
			long endTime = System.currentTimeMillis();
			DownloadTime = (endTime-startTime);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (XmlPullParserException e) {
			e.printStackTrace();
		} 
		return response;
	}
	
/*public Object HttpsCall() {
		
		String url = this.testURL;
		HttpsTransportSE transport = new HttpsTransportSE(url,443,"",60000);
		Object response = null;
		try {
			if(this.selfSigned) {
				try {
					trustCallback();
				} catch (KeyManagementException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchAlgorithmException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			long startTime = System.currentTimeMillis();
			transport.call(this.ACTION, soapEnvelope);
			response = soapEnvelope.getResponse();
			long endTime = System.currentTimeMillis();
			setDownloadTime((endTime-startTime)/1000);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (XmlPullParserException e) {
			e.printStackTrace();
		} 
		return response;
	}*/
	
	//trust manager - part of trust callback
	 static TrustManager[] trustAllCerts = new TrustManager[]{
	        new X509TrustManager() {
	            public java.security.cert.X509Certificate[] getAcceptedIssuers() {
	                return null;
	            }
	            public void checkClientTrusted(
	                java.security.cert.X509Certificate[] certs, String authType) {
	            }
	            public void checkServerTrusted(
	                java.security.cert.X509Certificate[] certs, String authType) {
	            }
	        }
	    };
	 //end trust manager
	
	//trust callback - if server has self-signed certificate we must use this
	private void trustCallback() throws NoSuchAlgorithmException, KeyManagementException {
		SSLContext context = SSLContext.getInstance("TLS");    	
		context.init(null,trustAllCerts,new java.security.SecureRandom());
		HttpsURLConnection.setDefaultSSLSocketFactory(context.getSocketFactory());
		HttpsURLConnection.setDefaultHostnameVerifier(new AllowAllHostnameVerifier());
	}
	//end trust callback

	

}
